/***************************************************************/
/* DISPLAY DIRECTORY FILES                                     */
/*                                                             */
/* Displays all files in a directory.                          */
/***************************************************************/

call setup_error_traps        /* set up the error trap routines*/
call set_window_1_values      /* set up values for ENTRY box   */
call RxCreate 'RX', 2, 'Main Window', 'NOCLOSE'

do forever                    /* do until user closes window   */

   call RxMsg                 /* invokes user interaction      */

   if RxID == '' then signal halt /* exit if users clicks CLOSE*/

   if RxID == '2' then do         /* continue if extension...  */

      result = '' ; list = ''

      do until result <> ''   /* get all files w/ the extension*/
         result = MatchName(, 'File', text.1)
         if result = '' then list = list || File || '|'
      end

      if list = '' then 
         call RxSay 'No files with this extension', 'OK', 'Warning!'

      else do 

         /* display results in 2nd window, a multi-line TEXT box*/

         Rx2 = ''                       /* Window ID is 'RX2'   */
         Rx2Type.1  = 'TEXT'            /* use a TEXT box       */
         Rx2Flags.1 = 'NOBORDER'        /* how the text displays*/
         Rx2Label.1 = list              /* the text to display  */
         Rx2Pos.1   = '1 8 18'          /* display position     */ 
         call RxCreate 'Rx2', 1, 'Text', 'RESULT' /* make window*/
         call RxMsg                     /* do the interaction   */
      end
   end
end


/*=============================================================*/

setup_error_traps:

/* trap errors for HALT/SYNTAX/ERROR, ask for ERROR raising    */

signal on halt
signal on syntax
signal on error
call RxErr 'ERROR|DISPLAY'    /* displays error messages       */

return


syntax:                       /* handle errors here.           */
halt:                         /* RxErr with DISPLAY option     */
error:                        /* displays a nice error msg box */
 
    call RxMsg,'END'          /* close ENTRY box window, exit  */
    exit


set_window_1_values:

/* set values for the Text Entry box window                    */

Rx = ''                       /* "RX" will be our Window ID    */

RxType.1  = 'MENU'            /* group type is MENU for a menu */ 
RxFlags.1 = ''
RxLabel.1 = 'MENU'
RxType.2  = 'ENTRY'           /* establish the ENTRY box       */
RxFlags.2 = 'REPORT'          /* through which the user will   */
RxLabel.2 = 'Enter file extension:|' /* enter a file extension */
RxPos.2   = '-1 5 5 150'
RxVal.2   = 'text'

return